oo-install-bootstrap.sh 2.8 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293
  1. #!/bin/sh
  2. # Grab command-line arguments
  3. cmdlnargs="$@"
  4. : ${OO_INSTALL_KEEP_ASSETS:="false"}
  5. : ${OO_INSTALL_CONTEXT:="INSTALLCONTEXT"}
  6. : ${TMPDIR:=/tmp}
  7. : ${OO_INSTALL_LOG:=${TMPDIR}/INSTALLPKGNAME.log}
  8. [[ $TMPDIR != */ ]] && TMPDIR="${TMPDIR}/"
  9. if rpm -q dnf;
  10. then
  11. PKG_MGR="dnf"
  12. else
  13. PKG_MGR="yum"
  14. fi
  15. if [ $OO_INSTALL_CONTEXT != 'origin_vm' ]
  16. then
  17. clear
  18. echo "Checking for necessary tools..."
  19. fi
  20. if [ -e /etc/redhat-release ]
  21. then
  22. for i in python python-virtualenv openssh-clients gcc
  23. do
  24. rpm -q $i >/dev/null 2>&1 || { echo >&2 "Missing installation dependency detected. Please run \"${PKG_MGR} install ${i}\"."; exit 1; }
  25. done
  26. fi
  27. for i in python virtualenv ssh gcc
  28. do
  29. command -v $i >/dev/null 2>&1 || { echo >&2 "OpenShift installation requires $i on the PATH but it does not appear to be available. Correct this and rerun the installer."; exit 1; }
  30. done
  31. # All instances of INSTALLPKGNAME are replaced during packaging with the actual package name.
  32. if [[ -e ./INSTALLPKGNAME.tgz ]]
  33. then
  34. if [ $OO_INSTALL_CONTEXT != 'origin_vm' ]
  35. then
  36. echo "Using bundled assets."
  37. fi
  38. cp INSTALLPKGNAME.tgz ${TMPDIR}/INSTALLPKGNAME.tgz
  39. elif [[ $OO_INSTALL_KEEP_ASSETS == 'true' && -e ${TMPDIR}/INSTALLPKGNAME.tgz ]]
  40. then
  41. if [ $OO_INSTALL_CONTEXT != 'origin_vm' ]
  42. then
  43. echo "Using existing installer assets."
  44. fi
  45. else
  46. echo "Downloading oo-install package to ${TMPDIR}INSTALLPKGNAME.tgz..."
  47. curl -s -o ${TMPDIR}INSTALLPKGNAME.tgz https://install.openshift.com/INSTALLVERPATHINSTALLPKGNAME.tgz
  48. fi
  49. if [ $OO_INSTALL_CONTEXT != 'origin_vm' ]
  50. then
  51. echo "Extracting oo-install to ${TMPDIR}INSTALLPKGNAME..."
  52. fi
  53. tar xzf ${TMPDIR}INSTALLPKGNAME.tgz -C ${TMPDIR} 2>&1 >> $OO_INSTALL_LOG
  54. echo "Preparing to install. This can take a minute or two..."
  55. virtualenv ${TMPDIR}/INSTALLPKGNAME 2>&1 >> $OO_INSTALL_LOG
  56. cd ${TMPDIR}/INSTALLPKGNAME 2>&1 >> $OO_INSTALL_LOG
  57. source ./bin/activate 2>&1 >> $OO_INSTALL_LOG
  58. pip install --no-index -f file:///$(readlink -f deps) ansible 2>&1 >> $OO_INSTALL_LOG
  59. # TODO: these deps should technically be handled as part of installing ooinstall
  60. pip install --no-index -f file:///$(readlink -f deps) click 2>&1 >> $OO_INSTALL_LOG
  61. pip install --no-index ./src/ 2>&1 >> $OO_INSTALL_LOG
  62. echo "Installation preparation done!" 2>&1 >> $OO_INSTALL_LOG
  63. echo "Using `ansible --version`" 2>&1 >> $OO_INSTALL_LOG
  64. if [ $OO_INSTALL_CONTEXT != 'origin_vm' ]
  65. then
  66. echo "Starting oo-install..." 2>&1 >> $OO_INSTALL_LOG
  67. else
  68. clear
  69. fi
  70. oo-install $cmdlnargs --ansible-playbook-directory ${TMPDIR}/INSTALLPKGNAME/openshift-ansible-*/ --ansible-log-path $OO_INSTALL_LOG
  71. if [ $OO_INSTALL_KEEP_ASSETS == 'true' ]
  72. then
  73. echo "Keeping temporary assets in ${TMPDIR}"
  74. else
  75. echo "Removing temporary assets."
  76. rm -rf ${TMPDIR}INSTALLPKGNAME
  77. rm -rf ${TMPDIR}INSTALLPKGNAME.tgz
  78. fi
  79. echo "Please see $OO_INSTALL_LOG for full output."
  80. exit